/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export class BaseClass {
    baseClassProperty: string;
}

export class DerivedClass extends BaseClass {
    id: string;
    derivedClassProperty: string;
}

export interface IBaseInterface {
    baseInterfaceProperty: string;
}

export interface IDerivedInterface extends IBaseInterface {
    id: number;
    derivedInterfaceProperty: string;
}

export type UnionType = IDerivedInterface | DerivedClass;

export type IntersectionType = IDerivedInterface & DerivedClass;

export class TestController {
    constructor(private fetcher: IFetcher) { }
    postClass = (params: DerivedClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/class/${params.baseClassProperty}/${params.derivedClassProperty}`, "post", "application/json", undefined, headers);
    };
    getClass = (params: DerivedClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/class/${params.baseClassProperty}/${params.derivedClassProperty}`, "get", "application/json", undefined, headers);
    };
    postInterface = (params: IDerivedInterface, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/interface/${params.baseInterfaceProperty}/${params.derivedInterfaceProperty}`, "post", "application/json", undefined, headers);
    };
    getInterface = (params: IDerivedInterface, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/interface/${params.baseInterfaceProperty}/${params.derivedInterfaceProperty}`, "get", "application/json", undefined, headers);
    };
    postUnion = (params: UnionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/union/${params.id}`, "post", "application/json", undefined, headers);
    };
    getUnion = (params: UnionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/union/${params.id}`, "get", "application/json", undefined, headers);
    };
    postIntersection = (params: IntersectionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/intersection/${params.baseInterfaceProperty}/${params.derivedInterfaceProperty}/${params.baseClassProperty}/${params.derivedClassProperty}`, "post", "application/json", undefined, headers);
    };
    getIntersection = (params: IntersectionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/intersection/${params.baseInterfaceProperty}/${params.derivedInterfaceProperty}/${params.baseClassProperty}/${params.derivedClassProperty}/test`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}